<template>
  <modal name="new-wallet"
         class="arcticmodal-container full-viewport"
         width="600"
         height="auto"
         :adaptive=true
         @before-open="beforeOpen"
          @before-close="beforeClose">
    <div class="container m-header ">
      <div
        @click="close()"
        class="box-modal_close arcticmodal-close"></div>
      <div class="row">
        <div class="column">
          <h3>Привязать Яндекс.Деньги</h3>
        </div>
      </div>
    </div>
    <div class="container feedback-block">
      <p>Все паспортные данные владельца кошелька Яндекс.Деньги должны полностью совпадать с данными, которые вы указали в анкете при оформлении займа.</p>
      <h3 class="text-header">Способы идентификации:</h3>
      <ol>
        <li>Подать заявление на идентификацию кошелька в офисе компании Яндекс.Деньги.</li>
        <li>Передать данные необходимые для идентификации через партнеров компании Яндекс.Деньги.</li>
        <li>Отправить необходимые данные в компанию Яндекс.Деньги по e-mail.</li>
      </ol>
      <p>Подробнее об идентификации кошелька можно прочитать на сайте <a href="https://money.yandex.ru/">money.yandex.ru</a> </p>
      <label for="new-wallet">Введите номер кошелька</label>
      <input name="для ввода номера яндекс кошелька"
             id="new-wallet"
             data-vv-validate-on="blur"
             v-validate="'required|min:11|max:16'"
             v-mask="'################'"
             v-model="walletNum"
             placeholder=""
             value=""
             class="free-message-space"
             type="text">
      <validate-message
        v-show="vErrors.has('для ввода номера яндекс кошелька')">
        {{ vErrors.first('для ввода номера яндекс кошелька') }}
      </validate-message>
      <div class="center">
        <button
                @click="validateBeforeSubmit"
                :class="{button_loading: getButtonLoading}"
                :disabled="getButtonLoading"
        >
          Привязать
        </button>
      </div>
    </div>
    <vuex-error-block></vuex-error-block>
  </modal>
</template>
<script>
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import {mapGetters} from 'vuex'
  import ErrorBuildingCardMap from '@/utils/error_mapper/building-card';

export default {
    name: 'new-wallet',
    data () {
      return {
        walletNum: '',
        time: 0,
        duration: 5000,
        params: {},
        disableButton: true,
        errorsForErrorBlock: []
      }
    },
  computed: {
    ...mapGetters(['getButtonLoading'])
  },
    mixins: [
      ErrorHandleMixin
    ],
    components: {
      ValidateMessage
    },
    methods: {
      async validateBeforeSubmit (event) {
        const allFieldsIsValidated = await this.$validator.validateAll()
        if (allFieldsIsValidated) {
          this.submit(event)
        }
      },
      async submit ({target}) {
        this.$store.commit('BUTTON_LOADING', true)
        try {
          const account = {
            'type': 3,
            'description': this.walletNum
          }
          await this.$store.dispatch('createAccount', account)
          this.$toastr.success('Кошелек привязан к вашему аккаунту', 'Успешно');
        } catch (e) {
          this.$error(e, ErrorBuildingCardMap, 'Произошла ошибка при привязке кошелька.')
        }
        this.$store.commit('BUTTON_LOADING', false)
      },
      beforeOpen (event) {
        this.params = event.params
        this.$helpers.noscroll(true)
      },
      beforeClose() {
        this.$helpers.noscroll(false)
      },
      close () {
        this.$modal.hide('new-wallet')
      }
    }
  }
</script>
<style scoped>
  h3 {
    margin-bottom: 0px !important;
  }
  .buttons {
    text-align: center
  }
</style>
